package de.oklein.android.ueberwachungssystem;

import androidx.fragment.app.Fragment;
import androidx.fragment.app.FragmentTransaction;
import androidx.appcompat.app.AppCompatActivity;

import android.os.Bundle;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ScrollView;
import android.widget.TextView;

import org.w3c.dom.Text;

public class MainActivity extends AppCompatActivity {
    private Fragment aktuellesFragment;
    private TextView alarm;
    private String text = "Das ist ein Alarm des Sensors";
    private void log(String nachricht) {
        Log.d(this.getClass().getSimpleName(), nachricht);
    }
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setTitle(this.getClass().getSimpleName());
        setContentView(R.layout.activity_main);
        alarm = findViewById(R.id.Alarm);
        alarm.setText(text);
    }
    public void onClickZeigeFragment1(View view) {
        Button button = (Button) view;
        log(button.getText() + " ausgewählt");
        zeigeFragment(Fragment1.erstellen("Fragment 1 wurde angeklickt"));
    }
    public void onClickZeigeFragment2(View view) {
        Button button = (Button) view;
        log(button.getText() + " ausgewählt");
        zeigeFragment(Fragment2.erstellen("Fragment 2 wurde angeklickt"));
    }

    public void onClickZeigeFragment3(View view) {
        Button button = (Button) view;
        log(button.getText() + " ausgewählt");
        zeigeFragment(Fragment3.erstellen("Fragment 3 wurde angeklickt"));
    }

    public void onClickEntferneFragment(View view) {
        entferneFragment();
    }
    private void zeigeFragment(Fragment fragment) {
        FragmentTransaction ft = getSupportFragmentManager().beginTransaction();
        ft.replace(R.id.frame, fragment);
        ft.commit();
        aktuellesFragment = fragment;
    }
    private void entferneFragment() {
        if (aktuellesFragment != null) {
            FragmentTransaction ft = getSupportFragmentManager().beginTransaction();
            ft.remove(aktuellesFragment);
            ft.commit();
            aktuellesFragment = null ;
        }
    }
    public static class Fragment1 extends Fragment {
        private String text;
        private final static String KEY_TEXT = "KEY_TEXT";

        private void log(String nachricht) {
            Log.d(this.getClass().getSimpleName(), nachricht);
        }

        @Override
        public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle bundle) {
            log("onCreateView");
            View view = inflater.inflate(R.layout.fragment1, container, false);
            TextView Sensor = (TextView) view.findViewById(R.id.Sensor);
            Sensor.setText(text);
            return view;
        }
        public static Fragment1 erstellen(String text) {
            Fragment1 fragment = new Fragment1();
            Bundle b = new Bundle();
            b.putString(KEY_TEXT, text);
            fragment.setArguments(b);
            return fragment;
        }
        @Override
        public void onCreate(Bundle bundle) {
            super .onCreate(bundle);
            Bundle args = getArguments();
            if (args != null ) {
                text = args.getString(KEY_TEXT);
                log("onCreate: text=" + text);
            } else {
                log("onCreate");
            }
        }
    }
    public static class Fragment2 extends Fragment {
        private String text;
        private final static String KEY_TEXT = "KEY_TEXT" ;
        private void log(String nachricht) {
            Log.d(this.getClass().getSimpleName(), nachricht);
        }
        @Override
        public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle bundle) {
            log( "onCreateView" );
            View view = inflater.inflate(R.layout.fragment2, container, false );
            TextView Sensor = (TextView) view.findViewById(R.id.Sensor);
            Sensor.setText(text);
            return view;
        }
        public static Fragment2 erstellen(String text) {
            Fragment2 fragment = new Fragment2();
            Bundle b = new Bundle();
            b.putString(KEY_TEXT, text);
            fragment.setArguments(b);
            return fragment;
        }
        @Override
        public void onCreate(Bundle bundle) {
            super.onCreate(bundle);
            Bundle args = getArguments();
            if (args != null) {
                text = args.getString(KEY_TEXT);
                log("onCreate: text=" + text);
            } else {
                log("onCreate");
            }
        }
    }

    public static class Fragment3 extends Fragment {
        private String text;
        private final static String KEY_TEXT = "KEY_TEXT" ;
        private void log(String nachricht) {
            Log.d(this.getClass().getSimpleName(), nachricht);
        }
        @Override
        public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle bundle) {
            log( "onCreateView" );
            View view = inflater.inflate(R.layout.fragment2, container, false );
            TextView Sensor = (TextView) view.findViewById(R.id.Sensor);
            Sensor.setText(text);
            return view;
        }
        public static Fragment3 erstellen(String text) {
            Fragment3 fragment = new Fragment3();
            Bundle b = new Bundle();
            b.putString(KEY_TEXT, text);
            fragment.setArguments(b);
            return fragment;
        }
        @Override
        public void onCreate(Bundle bundle) {
            super.onCreate(bundle);
            Bundle args = getArguments();
            if (args != null) {
                text = args.getString(KEY_TEXT);
                log("onCreate: text=" + text);
            } else {
                log("onCreate");
            }
        }
    }
}